RMIN=7;
RMAX=12;

FILENAME='f'
FILEEXT = '.jpg';
FILETYPE = 'jpg';
FILEREAD= strcat(FILENAME,'.jpg');
origimage = imread(FILEREAD);

DIMY = size(origimage,1);
DIMX = size(origimage,2);

img=double(edge(rgb2gray(origimage)));%ziskani sedotonoveho obrazu

%normalizace obrazu na jednicku
img = img - min(min(min(img)));
img = img / max(max(max(img)));

%ziskani jmen vystupnich souboru
FILETEMP = strcat(FILENAME, '-filtered');
FILETEMP = strcat(FILETEMP, FILEEXT);
imwrite(img, FILETEMP, FILETYPE);


res= zeros(RMAX, DIMY, DIMX);
%nalezeni poctu bodu lezicich na kruznicich o ruznych polomerech
count=0;
total=0;
circfunc = zeros(1, 10);
for r = RMIN:RMAX,
  r
  maxY = fix(r*cos(pi/4));
  for y = 1:(maxY),
      x=round(sqrt((r^2)-(y^2)));
      circfunc(y)=x;
  end

  for currX = 1:(DIMX),
    for currY= 1:(DIMY),
	[count, total] = testcirc(currX, currY, r, img, circfunc);
        res(r, currY, currX)=total;
        total=0;
        count=0;
    end
  end
end
%normalizace na jednicku
res = res - min(min(min(res)));
res = res / max(max(max(res)));
%ulozeni obrazku popisujich nalezene kruznice
for i = RMIN:RMAX,
  outputimage = reshape(res(i,:,:),[DIMY,DIMX]);
  outputimage = outputimage;
  FILETEMP = strcat(FILENAME, '-radius-');
  FILETEMP = strcat(FILETEMP, num2str(i));
  FILETEMP = strcat(FILETEMP, FILEEXT);
  imwrite(outputimage, FILETEMP, FILETYPE);
end


%nalezeni nejlepsi lruznice
[i,j,k] = find(res==1);
outputimage = reshape(res(i,:,:),[DIMY,DIMX]);
[j,k] = find(outputimage==1);


%save result circle
tempimage = zeros(DIMY,DIMX);
tempimage = drawcirc(k,j,i,tempimage);
finalimage = greyscale(tempimage);

FILETEMP = strcat(FILENAME, '-result');
FILETEMP = strcat(FILETEMP, FILEEXT);
imwrite(tempimage, FILETEMP, FILETYPE);
